;;;                                     "rucksack-gierig-mit-breakvalue-2008.scm"
(require (lib "breakpoint.ss"))
; ----- Liste der vorhandenen Stuecke -----
(define stuecke '(30 30 30 20 20 15 5 2 1))
; ----- Praedikate -----
(define (ziel? container zielwert)    (= zielwert (apply + container)))
(define (zu-voll? container zielwert) (< zielwert (apply + container)))
;;; ===== suche mit break-value =====
(define
  (suche liste container zielwert)
  (bkpt liste container (apply + container))
  (cond
    ((null? liste) (break-value "geht nicht!"))
    ((ziel? (cons (car liste) container) zielwert)
     (break-value (cons (car liste) container) "fertig!"))
    ((zu-voll? (cons (car liste) container) zielwert)
     (break-value
      (suche (cdr liste) container zielwert)
      "zu voll, ohne das Teil"
      (car liste)
      "weiter."))
    (else
     (break-value
      (suche (cdr liste) (cons (car liste) container) zielwert)
      "einbauen:"
      (car liste)
      "es bleiben:"
      (cdr liste)))))

; ----- Tests -----
(suche stuecke () 105)
(suche stuecke () 100)
