; "zufaellig.scm"
; Zufallswerte liefert die Funktion (random k), wir knnen den Zufallsgenerator mit 
; (random-seed k) setzen.

;;; ===== erzeuge-stueck =====
;;; Die Funktion liefert ein Stck zuflliger Gre zwischen
;;; dem Drittel und dem vollen Wert der bergebenen Maximalgre.
(define
  (erzeuge-stueck maximal-groesse)
  (+
   (quotient maximal-groesse 3)
   (random (quotient (* 2 maximal-groesse) 3))))

;;; ===== erzeuge-die-Stuecke =====
;;; Die Funktion liefert eine Liste von anzahl Stcken zuflliger Gre.
(define
  (erzeuge-die-Stuecke anzahl maxi)
  (cond
    ((zero? anzahl)
     ())
    (else
     (cons
      (erzeuge-Stueck maxi)
      (erzeuge-die-Stuecke (sub1 anzahl) maxi)))))

; test:
;(erzeuge-die-Stuecke 12 100)

;;; ===== erzeuge-Normstueck =====
;;; Die Funktion liefert ein Stck zuflliger Gre in Vielfachen
;;; einer Normgre zwischen einem minimalen Vielfachen mini
;;; und einem maximalen Vielfachen maxi.
(define
  (erzeuge-Normstueck norm mini maxi)
  (+
   (* norm mini)
   (* (random (- maxi mini)) norm)))
   
;;; ===== erzeuge-die-Normstuecke =====
;;; Die Funktion liefert eine Liste von anzahl Stcken zuflliger Gre oder
;;; in Vielfachen einer Normgre zwischen einem minimalen Vielfachen mini
;;; und einem maximalen Vielfachen maxi.
(define
  (erzeuge-die-Normstuecke anzahl norm mini maxi)
  (cond
    ((zero? anzahl)
     ())
    (else
     (cons
      (erzeuge-Normstueck norm mini maxi)
      (erzeuge-die-Normstuecke (sub1 anzahl) norm mini maxi)))))

;test
;(erzeuge-die-Normstuecke 12 10 3 10)

      