;;; <Missio Kani.scm>
(define Start-Zustand (vector 3 3 0 0))
;;; ===== zwei-Missionare-nach-rechts ===============================
; Liefert aus dem Startzustand den Zielzustand oder #f, wenn das
; Verschieben auf der Ausgangsseite zu einem unzulssigen Zustand
; fhrt.
(define 
  (zwei-Missionare-nach-rechts Zustand)
  (let
      ((Zustand Zustand))
    (cond
      ; es sind keine 2 Missionare vorhanden
      ((< (vector-ref Zustand 0) 2)
       #f)
      ; hinterher keine Missionare vorhanden
      ((= (vector-ref Zustand 0) 2)
       (vector-set! Zustand 0 0)
       Zustand)
      ; hinterher mehr Kannibalen
      ((< (sub1 (sub1 (vector-ref Zustand 0)))
          (vector-ref Zustand 1)) 
       #f)
      (else
       (vector-set! Zustand 0 (sub1 (sub1 (vector-ref Zustand 0))))
       Zustand))))
;(zwei-Missionare-nach-rechts Start-Zustand)
;(zwei-Missionare-nach-rechts  (vector 2 2 0 0))
;(zwei-Missionare-nach-rechts  (vector 3 2 0 0))
;(zwei-Missionare-nach-rechts  (vector 3 1 0 0))
;;; ===== zwei-Kannibalen-nach-rechts ===============================
; Liefert aus dem Startzustand den Zielzustand oder #f, wenn das
; Verschieben auf der Ausgangsseite zu einem unzulssigen Zustand
; fhrt.
(define 
  (zwei-Kannibalen-nach-rechts Zustand)
  (cond
    ; es sind keine 2 Kannibalen vorhanden
    ((< (vector-ref Zustand 1) 2)
     #f)
   (else
     (vector-set! Zustand 1 (sub1 (sub1 (vector-ref Zustand 1))))
     Zustand)))
(zwei-Kannibalen-nach-rechts Start-Zustand)
(zwei-Kannibalen-nach-rechts Start-Zustand)
(zwei-Kannibalen-nach-rechts  (vector 2 2 0 0))
(zwei-Kannibalen-nach-rechts  (vector 3 2 0 0))
(zwei-Kannibalen-nach-rechts  (vector 3 1 0 0))
;;; zeigt mit der Ausgabe 
;#4(3 1 0)
;#f
;#4(2 0)
;#4(3 0)
;#f
; ein Vernderung der Variablen Start-Zustnd selbst !!!
; So geht es also nicht !!!
