;;;                                 <binBaum.scm>
;;; Untersuchen Sie : Suchverfahren oder nicht ?
;;; -----------------------------------------------------------------
;;; Als Programmiertechnik wurden hier "Funktionen mit Zustand"
;;; gewhlt, also die Vorstufe zu OO Programmierung.
;;; Die Variablen Inhalt, links und rechts sind Attribute der Objekte
;;; vom Typ Knoten, die durch Auswerten der Funktion erzeuge-Knoten
;;; erzeugt werden. Ihr Wert sind Funktionen, also ein funktionale
;;; Objekte, die auf die messages (Botschaften) <Daten> bzw. '()
;;; reagieren knnen. Im ersten Fall werden die Daten eingefgt, im
;;; anderen Fall der Inhalt des Baumes sortiert angezeigt.
;;; ===== Sortieren im binaeren Baum ================================
;;; 
(define
  (erzeuge-Knoten der-Inhalt)
  (let
      ((Inhalt der-Inhalt)
       (links '())
       (rechts '()))
    (lambda 
	(Daten)
      (cond
	((null? Daten)
	 (append 
	  (if
	   (not (null? links))
	   (links Daten)
	   '())
	  (cons 
	   Inhalt
	   (if
	    (not (null? rechts))
	    (rechts Daten)
	   '()))))
	((null? Inhalt) (set! Inhalt Daten))
	((vor? Daten Inhalt)
	 (if
	  (null? links)
	  (set! links (erzeuge-Knoten Daten))
	  (links Daten)))
	(else
	 (if
	  (null? rechts)
	  (set! rechts (erzeuge-Knoten Daten))
	  (rechts Daten)))))))

(define
  (vor? Par1 Par2)
  (string<? (symbol->string Par1) (symbol->string Par2)))

(define
  Baum 
  (erzeuge-Knoten '()))

(Baum 'Kummer)
(Baum 'Hans)
(Baum 'Heiner)
(Baum 'Karotte)
(Baum 'Aal)
(Baum 'Kunde)
(Baum 'Hund)
(Baum 'Kumme)
(Baum 'Hummer)
(Baum '())
