;;;                                            (8 Damen neu zeit.scm)
;;;                                Albowski , 1'2001
(load "Laufzeiten.scm")
;;; 
;;; Gute HG+T
;;; -----------------------------------------------------------------
(require (lib "breakpoint.ss"))
    
;;; ===== Nachfolger ================================================
; Die Nachfolgerfunktion.
(define
  (Nachfolger zustand)
  (let loop
    ((index max-Zahl)
     (akku ()))
    (cond
      ((zero? index) akku)
      ((member index zustand) (loop (sub1 index) akku))
      ((diagonal-besetzt? (cons index zustand))
       (loop (sub1 index) akku))
      (else
       (loop (sub1 index) (cons (cons index zustand) akku))))))

;;; ===== diagonal-besetzt? =========================================
; Testet die Diagonalen.
(define
  (diagonal-besetzt? zustand)
  (let loop
    ((liste (cdr zustand))
     (rauf (add1 (car zustand)))
     (runter (sub1 (car zustand))))
    (cond
      ((null? liste) #f)
      ((= rauf (car liste)) #t)
      ((= runter (car liste)) #t)
      (else
       (loop (cdr liste) (add1 rauf) (sub1 runter))))))

;;; ===== Tiefensuche ===============================================
(define
  (Tiefensuche)
  (Zeit 'start)
  (let
      t-s
    ((Alternativen (Nachfolger ()))
     (besucht ()))
    (cond
      
      ((= (length besucht) max-Zahl)
       (writeln (Zeit 'miss))
       (Darstellung (car besucht))
       (car besucht))
      
      ((null? Alternativen) #f)
      
      ((member (car Alternativen) besucht)
       (t-s
        (cdr Alternativen)
        besucht))
      
      ((t-s
        (Nachfolger (car Alternativen))
        (cons (car Alternativen) besucht)))
      
      (else
       (t-s
        (cdr Alternativen)
        besucht)))))

;;; ===== Darstellung ===============================================
(define
  (Darstellung Damen)
  (let loop
    ((Anzahl (length Damen))
     (Damen Damen))
    (cond
      ((null? Damen) (newline))
      (else
       (stelle-Zeile-dar Anzahl (car Damen))
       (loop Anzahl (cdr Damen))))))

;;; ===== stelle-Zeile-dar ==========================================
(define
  (stelle-Zeile-dar Anzahl Spalte)
  (let loop
    ((Index 1))
    (cond
      ((> Index Anzahl) (newline))
      ((= Index Spalte) 
       (display " D ")
       (loop (add1 Index)))
      (else
       (display " * ")
       (loop (add1 Index))))))
  
;;;  4 -->     0 ms
;;;  5 -->    10 ms
;;;  6 -->    10 ms
;;;  7 -->     0 ms
;;;  8 -->    30 ms
;;;  9 -->    10 ms
;;; 10 -->    20 ms
;;; 11 -->      30 ms
;;; 12 -->     110 ms
;;; 13 -->      50 ms
;;; 14 -->     901 ms
;;; 15 -->     751 ms
;;; 16 -->    5718 ms
;;; 17 -->    3395 ms
;;; 18 -->   28190 ms
;;; 19 -->    1912 ms
;;; 20 -->  156485 ms =  2 min 36 s 485 ms
;;; 21 -->    7631 ms
;;; 22 --> 1585430 ms = 26 min 25 s 430 ms
;;; 23 -->   26979 ms
;;; 24 -->   ???
;;; 25 -->   61389 ms
;;; 26 -->   ???
;;; 27 -->  635404 ms = 10 min 35 s 404 ms
(define max-Zahl 8)
;;; =================================================================
(Tiefensuche)
