;;;                                     "rucksack-gierig-2008.scm"
(require (lib "breakpoint.ss"))
; ----- Liste der vorhandenen Stuecke -----
(define stuecke '(30 30 30 20 20 15 5 2 1))
; ----- Praedikate -----
(define (ziel? container zielwert)    (= zielwert (apply + container)))
(define (zu-voll? container zielwert) (< zielwert (apply + container)))
;;; ===== suche ohne break-value =====
(define
  (suche liste container zielwert)
  (cond
    ((null? liste) "geht nicht!")
    ((ziel? (cons (car liste) container) zielwert) (cons (car liste) container))
    ((zu-voll? (cons (car liste) container) zielwert)
     (suche (cdr liste) container zielwert))
    (else
     (suche (cdr liste) (cons (car liste) container) zielwert))))
; ----- Tests -----
(suche stuecke () 105)
(suche stuecke () 100)
