;;; "clp-ga-generation.scm"
;;; ===== Generationen-folge =====
(define
  (Generationen-folge pool anzahl)
  (cond
    ((zero? anzahl)
     pool)
    (else
     (Generationen-folge (Generation pool) (sub1 anzahl)))))

;;; ----- generation -----
; Fhrt einen Generationenschritt aus.
; es werden alle einmal mutiert und die besten aus den vorher vorhandenen und 
; den mutierten ausgewhlt.
(define
  (Generation pool)
  (Selektion
   (crossing-over 10 (Mutation pool '()) '())
   (length pool)
   0.30))
