;;; <entferne-element.scm>
;  element x liste --> liste ohne das erste auftretende element
;--- a) normal rekursive Variante
(define
  (entferne-element element liste)
  (cond
    ((null? liste)liste)
    ((equal? element (car liste))
     (cdr liste))
    (else
     (cons
      (car liste)
      (entferne-element element (cdr liste))))))

; Test
(entferne-element 'ele (list 1 2 'ele 'e 3 4 'element 'ele 5))

;--- b) endrekursive Variante
(define
  (entferne-element element liste)
  (let
      loop
    ((element element)
     (liste liste)
     (akku '()))
    (cond
      ((null? liste) (reverse akku))
      ((equal? element (car liste))
       (append (reverse akku) (cdr liste)))
      (else
       (loop
        element
        (cdr liste)
       (cons
        (car liste)
        akku))))))

; Test
(entferne-element 'ele (list 1 2 'ele 'e 3 4 'element 'ele 5))