;;; <sortiere.scm>
; In der Regel wird man bei den Suchproblemen selten
; groe Datenmengen sortieren, Sortieren durch Auswahl
; ist dann OK. Sonst nehmen man quicksort.
; vor? ist das Sortierprdikat.

; a) Sortieren durch Auswahl --- endrekursiv
(define
  (sortiere liste vor?)
  (if
   (null? liste)
   liste
   (let
       loop
     ((liste (cdr liste))
      (erstes (car liste))
      (unsortiert '())
      (sortiert '()))
     (cond
       ((and
         (null? liste)(null? unsortiert))    ; fertig !
        (reverse (cons erstes sortiert)))
        ((null? liste)                       ; ein Durchlauf fertig
         (loop
          (cdr unsortiert)
          (car unsortiert)
          '()
          (cons erstes sortiert)))
        ((vor? (car liste) erstes)
         (loop
          (cdr liste)
          (car liste)
          (cons erstes unsortiert)
          sortiert))
        (else
         (loop
          (cdr liste)
          erstes
          (cons (car liste) unsortiert)
          sortiert))))))

; test          
;(sortiere '(4 1 98 2 3 4 1 7 2 0) <)

; b) Sortieren durch Auswahl --- endrekursiv
(define
  (sortiere liste vor?)
  (if
   (null? liste)
   liste
   (let
       quick
     ((spaltelement (car liste))
      (liste (cdr liste))
      (vor '())
      (nach '()))
     (cond
       ((null? liste)
        (append
         (cond
           ((null? vor) '())
           ((null? (cdr vor)) vor)
           (else
            (quick (car vor)  (cdr vor) '() '())))
         (cons
          spaltelement
          (cond
            ((null? nach) '())
            ((null? (cdr nach)) nach)
            (else
             (quick (car nach)  (cdr nach) '() '()))))))
       ((vor? (car liste) spaltelement)
        (quick
         spaltelement
         (cdr liste)
         (cons (car liste) vor)
         nach))
       (else
        (quick
         spaltelement
         (cdr liste)
         vor
         (cons (car liste) nach)))))))
; test          
;(sortiere '(4 1 98 2 3 4 1 7 2 0) <)
